(*
   Thread scheduling in O'Caml test.
   ocamlc -thread  -custom unix.cma threads.cma -cclib -lunix -cclib -lthreads $1 -o $2
*)


open Unix
open ThreadUnix


let res = ref 0 
let s = Mutex.create()


let rec counter i = 
  Mutex.lock s;  res := i;  Mutex.unlock s;
  counter (i + 1)

(*
  let wait () = let _ = read_line () in ()
*)

(*
  let wait () = 
    let line = String.create 60 in
    let len = read stdin line 0 60 in
    print_string (String.sub line 0 len)
*)

  let wait () = 
    let rec loop i =
      if i < 3000000 then loop (i + 1) else i 
    in loop 0

(*
  let wait () = Unix.sleep 5
*)


let main () =
  let _ = Thread.create counter 0 in
  let t = Thread.create wait () in 
  Thread.join t;
(*
  wait();
*)
  Mutex.lock s;  print_int !res;  Mutex.unlock s


let _ = main ()


(*

open Unix
open ThreadUnix

let res = ref 0 
let s = Mutex.create()

(*
  let io () = 
    print_string "Hello!";
    let _ = read_line () in   
    Mutex.lock s;  print_int !res;  Mutex.unlock s
*)

  let io () = 
    print_string "Hello!";
    let line = String.create 60 in
    let len = read stdin line 0 60 in
    print_string (String.sub line 0 len);
    Mutex.lock s;  print_int !res;  Mutex.unlock s

  let wait () = 
    let ct = Thread.create io () in
    let rec counter i =
      if i < 1000000 then
       (Mutex.lock s;  res := i;  Mutex.unlock s;
        counter (i + 1)) 
      else ()
    in counter 0; Thread.join ct

(*
  let wait () = Unix.sleep 5
*)


let main () =
(*
  let _ = Thread.create counter 0 in
*)
  let t = Thread.create wait () in 
  Thread.join t;
(*
  wait();
*)
  Mutex.lock s;  print_int !res;  Mutex.unlock s


let _ = main ()


*)
